package rank

import (
	"testing"

	"github.com/stretchr/testify/assert"
)

func TestWeightingRelation(t *testing.T) {
	def := NewAlgorithmDefault()
	weightDef := def.WeightingRelation(1, 2, 5, 1, 10, 2, 2, 1, 15)

	assert.Equal(t, float32(0.44444445), weightDef)

	mix := NewAlgorithmMixed()
	weightMix := mix.WeightingRelation(1, 2, 5, 1, 10, 2, 2, 1, 15)

	assert.Equal(t, float32(0.2173913), weightMix)

	weightMix = mix.WeightingRelation(1, 2, 1, 1, 1, 1, 1, 1, 1)

	assert.Equal(t, float32(0), weightMix)
}

func TestWeightingHits(t *testing.T) {
	def := NewAlgorithmDefault()
	weightDef := def.WeightingHits(1, 5, 1, 10)

	assert.Equal(t, float32(0.44444445), weightDef)

	mix := NewAlgorithmMixed()
	weightMix := mix.WeightingHits(1, 5, 1, 10)

	assert.Equal(t, float32(0.44444445), weightMix)

	weightMix = mix.WeightingHits(1, 1, 1, 1)

	assert.Equal(t, float32(0), weightMix)
}
